﻿Imports System.ComponentModel
Imports System.Drawing.Drawing2D
Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary

Public Class Holl_Of_Fame

    Friend Nome_Giocatore As String = Giocatore.ToString.Trim
    Friend Data_ora As String = Date.Now.ToString.Trim
    Friend LIV_DIFF As Short = Livello_Diff
    Public Dati_Record() As String = {"Data/Ora", "Nome", "Punteggio", "Max_Valore", "Mosse", "Tempo"}

    'percorso file della classifica
    Private percorsofile As String = Directory.GetCurrentDirectory() + "\Risorse\Dati"

    'dichiaro la classe classifica
    Friend Classif_2048 As Classifica_2048

    'dichiaro oggetto streem classifica
    Friend myStremObjet_Classif As Classifica_2048

    Public Sub New()

        ' La chiamata è richiesta dalla finestra di progettazione.
        InitializeComponent()

        ' Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent().

    End Sub

    Private Sub Exxit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Exxit.Click

        Me.Close()
    End Sub

    Private Sub FrmHallOfFame_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

        Dim colore1 As Color = Color.Blue
        Dim colore2 As Color = Color.Red
        Dim gradient_brush As New LinearGradientBrush(New Point(0, 0), New Point(Me.Width, 0), colore1, colore2)

        e.Graphics.FillRectangle(gradient_brush, 0, 0, Me.Width, Me.Height)

    End Sub

    Public Function Nome_Difficoltà(ByRef ld As Short) As String

        Dim nld As String = "Difficoltà_Facile"

        Select Case ld
            Case 0
                nld = "Difficoltà_Facile"
            Case 1
                nld = "Difficoltà_Media"
            Case 2
                nld = "Difficoltà_Difficile"
            Case 3
                nld = "Difficoltà_Molto_Difficile"
        End Select

        Return nld
    End Function

    Private Sub Holl_Of_Fame_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'avvio procedure
        Dim Tmp As String = Convert.ToString(Form1.Tempo)
        Dim oms() As String = Tmp.Split(" ")
        Dati_Record(0) = Data_ora
        Dati_Record(1) = Nome_Giocatore
        Dati_Record(2) = Convert.ToString(Form1.Punteggio)
        Dati_Record(3) = Convert.ToString(Form1.Max_Potenza_Raggiunta)
        Dati_Record(4) = Convert.ToString(Form1.mosse)
        Dati_Record(5) = oms(1).Trim
        Dim nomeDiff As String = Nome_Difficoltà(LIV_DIFF)

        'instanzio la classe classifica
        Classif_2048 = New Classifica_2048(Nome_Giocatore, Data_ora, nomeDiff)
        'instanzio oggetto streem classifica
        myStremObjet_Classif = New Classifica_2048(Nome_Giocatore, Data_ora, nomeDiff)

        Call Carica_Tabella("Classifica_" & nomeDiff.Trim)
        'aggiorna la classifica             'aggiunta modifica da Ultimo il 4-7-2018 ore 18
        If (Nuovo_Record Or Win) And RS = False Then Call Aggiorna_Tabella_Classifica() ': RS = True '-------------- Ultimo 11-7-2018 ore 23
        Call Vedi_Tabella_Classifica()
        Me.Text += "  " & nomeDiff

        Me.KeyPreview = True

    End Sub

    Private Sub Holl_Of_Fame_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing

        'cancella gli oggetti in memoria.
        myStremObjet_Classif = Nothing
        Classif_2048 = Nothing
        Form1.Enabled = True
    End Sub

    Public Sub Carica_Tabella(ByVal nomtab As String)

        myStremObjet_Classif = Classif_2048
        percorsofile += "\" & nomtab & ".bin"
        If File.Exists(percorsofile) Then
            Dim File_Stream As Stream = File.OpenRead(percorsofile)
            Dim deserializer As New BinaryFormatter
            myStremObjet_Classif = CType(deserializer.Deserialize(File_Stream), Classifica_2048)
            File_Stream.Close()
        Else
            Dim File_Stream As Stream = File.Create(percorsofile)
            Dim serializer As New BinaryFormatter
            serializer.Serialize(File_Stream, myStremObjet_Classif)
            File_Stream.Close()
        End If

    End Sub

    Public Sub Vedi_Tabella_Classifica()

        Me.DGV_Classifica.Rows.Clear()
        'quantità totale di elementi.
        Dim ntc As Int32 = myStremObjet_Classif.QTED
        'se il dizionario è vuoto esce dalla sub.
        If ntc = 0 Then Exit Sub

        'Inserisco i dati nel datagridview.
        Dim a As String = ""
        Dim b As String = ""
        Dim c As Double
        Dim d As Double
        Dim e As Double
        Dim f As String = ""

        Try
            With myStremObjet_Classif

                For Each k As String In .Db_Classifica2048.Keys
                    a = .Db_Classifica2048(k)(1)
                    b = .Db_Classifica2048(k)(2)
                    c = Convert.ToDouble(.Db_Classifica2048(k)(3))
                    d = Convert.ToDouble(.Db_Classifica2048(k)(4))
                    e = Convert.ToDouble(.Db_Classifica2048(k)(5))
                    f = .Db_Classifica2048(k)(6)

                    Me.DGV_Classifica.Rows.Add(a, b, c, d, e, f)
                Next
                Dim Column As DataGridViewColumn
                Column = DGV_Classifica.Columns(2)
                Dim direction As ListSortDirection
                direction = ListSortDirection.Descending
                Me.DGV_Classifica.Sort(Column, direction)
                If direction = ListSortDirection.Ascending Then
                    Column.HeaderCell.SortGlyphDirection = SortOrder.Ascending
                Else
                    Column.HeaderCell.SortGlyphDirection = SortOrder.Descending
                End If
            End With
        Catch ex As Exception
            MsgBox(ex.Message.ToString + " Tutto OK ", MsgBoxStyle.Information)
        End Try

    End Sub

    Public Function Fun_immeti_dati(ByVal ind As Int32) As Dictionary(Of String, String())
        Dim DCl As New Dictionary(Of String, String())

        If Not DCl.ContainsKey(ind.ToString.Trim) Then
            DCl.Add(ind.ToString.Trim, {ind.ToString.Trim, Dati_Record(0), Dati_Record(1), Dati_Record(2), Dati_Record(3), Dati_Record(4), Dati_Record(5)})
        Else

        End If

        Return DCl
    End Function

    Public Sub Aggiorna_Tabella_Classifica()

        If myStremObjet_Classif.QTED = 0 Then

            myStremObjet_Classif.Inizializza_DB_Classifica2048()
        End If
        Dim indice As Int32 = myStremObjet_Classif.Indx_classifica + 1
        'Procedure di aggiornamento Classifica Tabella.
        myStremObjet_Classif.Aggiorna_DB_Classifica(Fun_immeti_dati(indice))
        myStremObjet_Classif.Data_Ora_Record_Aggiornamento = Data_ora.ToString
        myStremObjet_Classif.Nome_Utente = Nome_Giocatore
    End Sub

    Public Sub Salva_Tabella_Classifica()

        Call Serializza_File_Tabella(myStremObjet_Classif)

    End Sub

    Public Sub Resetta_Tabella_Classifica()

        myStremObjet_Classif.Resetta_Db_Classifica()
    End Sub

    Friend Sub Serializza_File_Tabella(ByRef FTO As Object)
        Dim File_Stream As Stream = Nothing
        Try
            File_Stream = File.Create(percorsofile)
            Dim serializer As New BinaryFormatter
            serializer.Serialize(File_Stream, FTO)
            File_Stream.Close()
            MsgBox("Il File della Classifica è stato Salvato", MsgBoxStyle.Information)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub Eraser_Click(sender As Object, e As EventArgs) Handles Eraser.Click
        If MessageBox.Show("Vuoi cancellare la Classifica?", "2048+", MessageBoxButtons.YesNo) = DialogResult.No Then
            Return
        End If
        Me.DGV_Classifica.Rows.Clear()
        Call Resetta_Tabella_Classifica()
        Me.Refresh()
    End Sub

    Private Sub Save_Click(sender As Object, e As EventArgs) Handles Save.Click
        If MessageBox.Show("Vuoi salvare il tuo Punteggio?", "2048+", MessageBoxButtons.YesNo) = DialogResult.No Then
            Return
        End If
        'memorizza i dati
        Call Salva_Tabella_Classifica()
        RS = True  '-------------- Ultimo 11-7-2018 ore 23
    End Sub

    Private Sub Holl_Of_Fame_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.F10 Then Me.Close()
    End Sub

End Class