﻿Imports System.IO

Module Module_Classi_Funzioni_Variabili

#Region "Variabili globali"

    'segniala obbiettivo raggiunto
    Public Win As Boolean

    'segniala nuovo record punteggio
    Public Nuovo_Record As Boolean

    'record salvato
    Public RS As Boolean

    'livello difficoltà gioco
    Public Livello_Diff As Short

    'bonus back
    Public Back_Bonus As Short

    'Instanziamo la Classe Holl Of Fame
    Public Classifica_Gioco As Holl_Of_Fame

    'random 2-4 80%
    Public opz1() As Int32 = {2, 2, 2, 2, 4}

    'random 2-4 90%
    Public opz2() As Int32 = {2, 2, 2, 2, 2, 2, 2, 2, 2, 4}

    'random 2-4 selezionato
    Public opz_Scelta() As Int32 = {}

    'nome del giocatore corrente
    Public Giocatore As String

    'ripresa partita
    Public RigaLettaInSospensione() As String

    'tempo totale delle sospensioni (break)
    Public BreakTime As Double = 0

#End Region

#Region "Classi e Funzioni globali"

    'verifica presenza cartelle gioco Mikelius
    Public Sub CheckDirectory()
        Dim datiDir As String = ".\Risorse\Dati"
        Dim GuidaDir As String = ".\Risorse\Guida"
        Dim ReplayDir As String = ".\Risorse\Replay"

        If Not Directory.Exists(datiDir) Then
            Directory.CreateDirectory(datiDir)
        End If
        If Not Directory.Exists(GuidaDir) Then
            Directory.CreateDirectory(GuidaDir)
        End If
        If Not Directory.Exists(ReplayDir) Then
            Directory.CreateDirectory(ReplayDir)
        End If
    End Sub

    ''' <summary>
    ''' indici livello difficoltà
    ''' </summary>
    Enum Difficoltà
        Facile 'index 0
        Media
        Difficile
        Molto_Difficile 'index 3
    End Enum

    ''' <summary>
    ''' Classe classifica serializzabile
    ''' </summary>
    <Serializable()>
    Public Class Classifica_2048
        'Delegato.----------------

        '-------------------------end

        'Parametri.---------------
        Public Livello_Difficoltà As String = "liv_diff"

        Public Nome_Utente As String = "Nome Utente"
        Public Data_Ora_Record_Aggiornamento As String = "----/----/----"
        Public Indx_classifica As Int32 = 0

        'Dizionario classifica 2048
        Private _Db_Classifica2048 As New Dictionary(Of String, String())

        'Quantità Totale Elementi Dizionario.
        Public QTED As Integer

        Public Property Db_Classifica2048 As Dictionary(Of String, String())
            Get
                Return _Db_Classifica2048
            End Get
            Set(ByVal value As Dictionary(Of String, String()))
                _Db_Classifica2048 = value
            End Set
        End Property

        '-------------------------end

        'Funzioni e Procedure.----

        Public Sub Inizializza_DB_Classifica2048()
            'numero progressivo.
            Dim Numero As Int32 = Indx_classifica

            For i As Int32 = 1 To 1

                Numero += i
                Db_Classifica2048.Add(Numero.ToString, {Numero.ToString, "0", "0", "0", "0", "0", "0", "0", "0", "0"})
            Next i

            QTED = Db_Classifica2048.Count
            Indx_classifica = QTED - 1
        End Sub

        Public Sub Resetta_Db_Classifica()

            Db_Classifica2048.Clear()
        End Sub

        Public Sub Aggiorna_DB_Classifica(ByVal Dati_DB As Dictionary(Of String, String()))

            'numero progressivo.
            Dim np As Int32 = Indx_classifica

            For Each Kn In Dati_DB.Keys

                If Not Db_Classifica2048.ContainsKey(Kn) Then
                    np += 1
                    Db_Classifica2048.Add(Kn, {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0"})
                    Db_Classifica2048(Kn)(0) = np.ToString
                    Db_Classifica2048(Kn)(1) = Dati_DB(Kn)(1)
                    Db_Classifica2048(Kn)(2) = Dati_DB(Kn)(2)
                    Db_Classifica2048(Kn)(3) = Dati_DB(Kn)(3)
                    Db_Classifica2048(Kn)(4) = Dati_DB(Kn)(4)
                    Db_Classifica2048(Kn)(5) = Dati_DB(Kn)(5)
                    Db_Classifica2048(Kn)(6) = Dati_DB(Kn)(6)
                Else

                    Db_Classifica2048(Kn)(1) = Dati_DB(Kn)(1)
                    Db_Classifica2048(Kn)(2) = Dati_DB(Kn)(2)
                    Db_Classifica2048(Kn)(3) = Dati_DB(Kn)(3)
                    Db_Classifica2048(Kn)(4) = Dati_DB(Kn)(4)
                    Db_Classifica2048(Kn)(5) = Dati_DB(Kn)(5)
                    Db_Classifica2048(Kn)(6) = Dati_DB(Kn)(6)
                End If

            Next

            QTED = Db_Classifica2048.Count
            Indx_classifica = QTED - 1
        End Sub

        '-------------------------end

        'Costruttore.-------------
        Sub New(ByVal nomeUtente As String, ByVal Data_ora As String, ByVal Diff As String)

            Nome_Utente = nomeUtente
            Data_Ora_Record_Aggiornamento = Data_ora
            QTED = Db_Classifica2048.Count
            Indx_classifica = QTED - 1
            Livello_Difficoltà = Diff

        End Sub

        '-------------------------end

    End Class

    'Procedura per la gestione dei livelli di difficoltà
    Public Sub Gestione_Difficolta_Livello(livello As Integer)

        Form1.FacileToolStrip.Checked = False
        Form1.MediaToolStrip.Checked = False
        Form1.DifficileToolStrip.Checked = False
        Form1.MoltoDifficileToolStrip.Checked = False

        Select Case livello
            Case = Difficoltà.Facile
                Back_Bonus = 8
                Form1.Butt_1PassoBack.Text = Back_Bonus.ToString()
                Form1.FacileToolStrip.Checked = True
                Form1.RadioBF.Checked = True
                opz_Scelta = opz2.ToArray
                Form1.Lbl_Diff.Text = "Diff: Facile"
            Case = Difficoltà.Media
                Back_Bonus = 4
                Form1.Butt_1PassoBack.Text = Back_Bonus.ToString()
                Form1.MediaToolStrip.Checked = True
                Form1.RadioBM.Checked = True
                opz_Scelta = opz2.ToArray
                Form1.Lbl_Diff.Text = "Diff: Media"
            Case = Difficoltà.Difficile
                Back_Bonus = 2
                Form1.Butt_1PassoBack.Text = Back_Bonus.ToString()
                Form1.DifficileToolStrip.Checked = True
                Form1.RadioBD.Checked = True
                opz_Scelta = opz2.ToArray
                Form1.Lbl_Diff.Text = "Diff: Difficile"
            Case = Difficoltà.Molto_Difficile
                Back_Bonus = 1
                Form1.Butt_1PassoBack.Text = Back_Bonus.ToString()
                Form1.MoltoDifficileToolStrip.Checked = True
                Form1.RadioBMoreD.Checked = True
                opz_Scelta = opz1.ToArray
                Form1.Lbl_Diff.Text = "Diff: Molto_Difficile"
        End Select

    End Sub

    'Procedura per la gestione dei bonus
    Public Sub Premio_Bonus(ByVal ld As Short)

        Select Case ld
            Case = Difficoltà.Facile
                Back_Bonus += 6
                Form1.Butt_1PassoBack.Text = Back_Bonus

            Case = Difficoltà.Media
                Back_Bonus += 3
                Form1.Butt_1PassoBack.Text = Back_Bonus

            Case = Difficoltà.Difficile
                Back_Bonus += 2
                Form1.Butt_1PassoBack.Text = Back_Bonus

            Case = Difficoltà.Molto_Difficile
                Back_Bonus += 1
                Form1.Butt_1PassoBack.Text = Back_Bonus

        End Select

    End Sub

    ' aggiunto Carlo 8-7-2018
    Public Function Cripta(ByVal Stringa As String) As String
        Dim _criptata As String = ""
        Dim ChiaveArray() As Byte = {10, 1, 12, 8, 7, 4, 9, 11, 2, 6, 5}
        For i = 0 To Stringa.Length - 1
            _criptata &= Convert.ToChar(Convert.ToInt32(Stringa.Chars(i)) + ChiaveArray(i Mod 11))
        Next
        Return _criptata
    End Function

    ' aggiunto Carlo 8-7-2018
    Public Function DeCripta(ByVal Stringa As String) As String
        Dim _decriptata As String = ""
        Dim ChiaveArray() As Byte = {10, 1, 12, 8, 7, 4, 9, 11, 2, 6, 5}
        For i = 0 To Stringa.Length - 1
            _decriptata &= Convert.ToChar(Convert.ToInt32(Stringa.Chars(i)) - ChiaveArray(i Mod 11))
        Next
        Return _decriptata
    End Function

#End Region

End Module